﻿IF OBJECT_ID('NoteReminderRecipient') IS NULL
 BEGIN
	-- Create new table
	CREATE TABLE [dbo].[NoteReminderRecipient](
		[Id] [bigint] NOT NULL,
		[RecipientEntityType] [int] NOT NULL,
		[RecipientEntityId] [bigint] NOT NULL,
		[NoteReminderId] [bigint] NOT NULL,
	PRIMARY KEY CLUSTERED 
	(
		[Id] ASC
	)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
	) ON [PRIMARY]

	ALTER TABLE [dbo].[NoteReminderRecipient]  WITH CHECK ADD FOREIGN KEY([NoteReminderId])
	REFERENCES [dbo].[NoteReminder] ([Id])
	ALTER TABLE [dbo].[NoteReminderRecipient] ADD  DEFAULT ((0)) FOR [NoteReminderId]
	
	-- Move data from current Notes and reminders table to associated recipient table
	BEGIN TRANSACTION
	DECLARE @IdsRequired bigint
	DECLARE @NextId bigint
	DECLARE @EndOfBlockNextId bigint
	DECLARE @NoteReminderId	BIGINT
	DECLARE @LocalisationId bigint
	DECLARE @NotesAndReminders TABLE (NoteReminderId BIGINT, UserId BIGINT, Processed BIT)

	INSERT INTO
		@NotesAndReminders
		(
			NoteReminderId,
			UserId,
			Processed
		)
	SELECT
		Id,
		ReminderUserId,
		0
	FROM
		NoteReminder
	WHERE
		noteremindertype = 1 -- Only reminders need to be removed
	AND ReminderUserId IS NOT NULL
	
	SET @IdsRequired = @@ROWCOUNT + 5

	UPDATE KeyTable SET NextId = NextId + @IdsRequired

	SELECT @EndOfBlockNextId = NextId FROM KeyTable

	SELECT @NextId = @EndOfBlockNextId - @IdsRequired

	WHILE EXISTS (SELECT 1 FROM @NotesAndReminders WHERE Processed = 0)
	BEGIN
		SELECT TOP 1
			@NoteReminderId = NoteReminderId
		FROM
			@NotesAndReminders
		WHERE
			Processed = 0
		INSERT INTO
			NoteReminderRecipient
			(
				Id,
				RecipientEntityType,
				RecipientEntityId,
				NoteReminderId
			)
			SELECT
				@NextId,
				2, -- Any existing data will always be User types
				UserId,
				@NoteReminderId
			FROM
				@NotesAndReminders
			WHERE
				NoteReminderId = @NoteReminderId
	
		SET @NextId = @NextId + 1
	
		UPDATE
			@NotesAndReminders
		SET
			Processed = 1
		WHERE
			NoteReminderId = @NoteReminderId

	END

	SELECT @IdsRequired = 10

	UPDATE KeyTable SET NextId = NextId + @IdsRequired

	SELECT @EndOfBlockNextId = NextId FROM KeyTable

	SELECT @NextId = @EndOfBlockNextId - @IdsRequired

	INSERT INTO EmailTemplate (Id, EmailTemplateType, [Subject], Body, Salutation, Recipient)
	VALUES (@NextId, 17, 'Sent from #FOCUSASSIST#; Reminder for you', 'This is a reminder for #EMPLOYERNAME#.

The reminder reads:

#REMINDER#

This is an automated email generated by #FOCUSASSIST#, please do not reply to this address.

Regards  #SENDERNAME#', 'Dear #RECIPIENTNAME#', Null)

	SELECT @NextId = @NextId + 1

	INSERT INTO EmailTemplate (Id, EmailTemplateType, [Subject], Body, Salutation, Recipient)
	VALUES (@NextId, 18, 'Sent from #FOCUSASSIST#; Reminder for you', 'This is a reminder for yourself.

The reminder reads:

#REMINDER#

This is an automated email generated by #FOCUSASSIST#, please do not reply to this address.

Regards  #SENDERNAME#', 'Dear #RECIPIENTNAME#', Null)

	SELECT @NextId = @NextId + 1

	INSERT INTO EmailTemplate (Id, EmailTemplateType, [Subject], Body, Salutation, Recipient)
	VALUES (@NextId, 20, 'Sent from #FOCUSASSIST#; Reminder for you', 'This is a reminder for yourself.

The reminder reads:

#REMINDER#

This is an automated email generated by #FOCUSASSIST#, please do not reply to this address.

Regards  #SENDERNAME#', 'Dear #RECIPIENTNAME#', Null)

	SELECT @LocalisationId = [Id] FROM Localisation WHERE Culture = '**-**'
	SELECT @NextId = @NextId + 1

	INSERT INTO LocalisationItem (Id, [Key], [Value], LocalisationId, ContextKey, Localised)
	VALUES(@NextId, 'AlertMessage.BusinessUnitReminder', 'Reminder for {0}, posted on {1} - {2}', @LocalisationId, '', 0)

	SELECT @NextId = @NextId + 1
	
	INSERT INTO LocalisationItem (Id, [Key], [Value], LocalisationId, ContextKey, Localised)
	VALUES(@NextId, 'AlertMessage.EmployeeReminder', 'Reminder from {0} {1}, posted on {2} - {3}', @LocalisationId, '', 0)
	
	SELECT @NextId = @NextId + 1
	
	INSERT INTO LocalisationItem (Id, [Key], [Value], LocalisationId, ContextKey, Localised)
	VALUES(@NextId, 'AlertMessage.JobSeekerReminder', 'Reminder from {0} {1}, posted on {2} - {3}', @LocalisationId, '', 0)

	COMMIT TRANSACTION

	UPDATE LocalisationItem SET VALUE = 'Reminder for {0} ({1}), posted on {2} - {3}' WHERE [Key] = 'AlertMessage.JobReminder'

	-- Create BusinessUnitUser view
	EXEC ('CREATE VIEW [dbo].[BusinessUnitUser] as
	select NEWID() AS Id, ebu.BusinessUnitId, u.Id as UserId, u.[Enabled] from employeebusinessunit ebu inner join employee e on ebu.EmployeeId = e.Id inner join [User] u on e.PersonId = u.PersonId')
	
	-- Drop column from Notes/Reminders
	DECLARE @FKName NVARCHAR(300)

	SELECT
		@FKName = f.name
	FROM
		sys.foreign_keys AS f
	INNER JOIN sys.foreign_key_columns AS fc
		ON f.OBJECT_ID = fc.constraint_object_id
	WHERE
		OBJECT_NAME(f.parent_object_id) = 'NoteReminder'
		AND COL_NAME(fc.parent_object_id,fc.parent_column_id) = 'ReminderUserId'
	
	EXEC ('ALTER TABLE NoteReminder DROP CONSTRAINT [' + @FKName + ']')
	ALTER TABLE [NoteReminder] DROP COLUMN [ReminderUserId];
	
 END
ELSE
 BEGIN
	PRINT 'Table already created, script will not be run'
 END